## Adjust inventory counters

### cURL

```
curl --request POST \
  --url https://api.fabric.inc/v3/inventories/actions/find-and-adjust-inventory-counters \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-channel-id: <x-fabric-channel-id>' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '
{
  "counters": {
    "onHand": 100
  },
  "locationNumber": 12345,
  "sku": "SKU1",
  "inventoryId": "723910d81723",
  "isNoStock": false,
  "itemId": 12345,
  "status": " IN_STOCK",
  "virtualCountersStatus": {
    "availableBackorder": "<string>",
    "availablePreorder": "<string>",
    "availableToPurchase": "<string>"
  }
}
'
```

### Python Example

```python
import requests

url = "https://api.fabric.inc/v3/inventories/actions/find-and-adjust-inventory-counters"

payload = {
    "counters": { "onHand": 100 },
    "locationNumber": 12345,
    "sku": "SKU1",
    "inventoryId": "723910d81723",
    "isNoStock": False,
    "itemId": 12345,
    "status": " IN_STOCK",
    "virtualCountersStatus": {
        "availableBackorder": "<string>",
        "availablePreorder": "<string>",
        "availableToPurchase": "<string>"
    }
}
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "x-fabric-channel-id": "<x-fabric-channel-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript Example

```javascript
const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    'x-fabric-channel-id': '<x-fabric-channel-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    counters: {onHand: 100},
    locationNumber: 12345,
    sku: 'SKU1',
    inventoryId: '723910d81723',
    isNoStock: false,
    itemId: 12345,
    status: ' IN_STOCK',
    virtualCountersStatus: {
      availableBackorder: '<string>',
      availablePreorder: '<string>',
      availableToPurchase: '<string>'
    }
  })
};

fetch('https://api.fabric.inc/v3/inventories/actions/find-and-adjust-inventory-counters', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP Example

```php
$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/inventories/actions/find-and-adjust-inventory-counters",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'counters' => [
        'onHand' => 100
    ],
    'locationNumber' => 12345,
    'sku' => 'SKU1',
    'inventoryId' => '723910d81723',
    'isNoStock' => false,
    'itemId' => 12345,
    'status' => ' IN_STOCK',
    'virtualCountersStatus' => [
        'availableBackorder' => '<string>',
        'availablePreorder' => '<string>',
        'availableToPurchase' => '<string>'
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-fabric-channel-id: <x-fabric-channel-id>",
    "x-fabric-tenant-id: <x-fabric-tenant-id>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
```

### Go Example

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://api.fabric.inc/v3/inventories/actions/find-and-adjust-inventory-counters"

payload := strings.NewReader("{\n  \"counters\": {\n    \"onHand\": 100\n  },\n  \"locationNumber\": 12345,\n  \"sku\": \"SKU1\",\n  \"inventoryId\": \"723910d81723\",\n  \"isNoStock\": false,\n  \"itemId\": 12345,\n  \"status\": \" IN_STOCK\",\n  \"virtualCountersStatus\": {\n    \"availableBackorder\": \"<string>\",\n    \"availablePreorder\": \"<string>\",\n    \"availableToPurchase\": \"<string>\"\n  }\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-fabric-tenant-id", "<x-fabric-tenant-id>")
	req.Header.Add("x-fabric-channel-id", "<x-fabric-channel-id>")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Response
#### 200

```json
{
  "backorderLimit": 50,
  "backorderShipmentAt": "2022-08-01T20:03:28.483Z",
  "channelId": "channel_xyz",
  "counters": {
    "allocated": 10,
    "onHand": 100,
    "shipped": 20
  },
  "createdAt": "2022-08-01T18:03:28.483Z",
  "customAttributes": {
    "isBopis": true
  },
  "hasInfiniteInventory": false,
  "inventoryId": "723910d81723",
  "isNoStock": false,
  "itemId": 12345,
  "leadTime": "5 days",
  "locationNumber": 12345,
  "lowStock": 10,
  "networkCode": "ShipToHome",
  "networkCounters": {
    "softReserve": 10
  },
  "preorderLimit": 40,
  "preorderShipmentAt": "2022-08-01T20:03:28.483Z",
  "region": "North America",
  "safetyStock": 10,
  "sku": "SKU1",
  "status": " IN_STOCK",
  "type": "primary",
  "updatedAt": "2022-08-01T20:03:28.483Z",
  "vendorId": "vendor1",
  "virtualCounters": {
    "availableBackorder": "<string>",
    "availablePreorder": "<string>",
    "availableToPurchase": "<string>"
  },
  "virtualCountersStatus": {
    "availableBackorder": "<string>",
    "availablePreorder": "<string>",
    "availableToPurchase": "<string>"
  }
}
```

#### 400

```json
{
  "errors": [
    {
      "message": "Invalid request",
      "type": "CLIENT_ERROR"
    }
  ],
  "message": "Bad request",
  "type": "CLIENT_ERROR"
}
```

#### 401

```json
{
  "message": "Unauthorized request",
  "type": "CLIENT_ERROR"
}
```

#### 404

```json
{
  "message": "inventory or counter code not found",
  "type": "CLIENT_ERROR"
}
```

#### 500

```json
{
  "message": "Internal server error",
  "type": "SERVER_ERROR"
}
```
